SystemOrganization addCategory: #'FastCGI-Server'!
SystemOrganization addCategory: #'FastCGI-Protocol'!
SystemOrganization addCategory: #'FastCGI-Stream'!
SystemOrganization addCategory: #'FastCGI-Records'!
SystemOrganization addCategory: #'FastCGI-Seaside'!

Object subclass: #FCGIHeader
	instanceVariableNames: 'version type requestId contentLength paddingLength reserved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Records'!

!FCGIHeader methodsFor: 'accessing' stamp: 'dl 2/14/2007 19:00'!
contentLength
	^contentLength ifNil: [0]! !

!FCGIHeader methodsFor: 'accessing' stamp: 'dl 2/14/2007 18:59'!
contentLength: anInteger
	contentLength := anInteger! !

!FCGIHeader methodsFor: 'accessing' stamp: 'dl 2/14/2007 19:01'!
paddingLength
	^paddingLength ifNil: [0]! !

!FCGIHeader methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 00:35'!
readFrom: aStream
	version := aStream uint8.
	type := aStream uint8.
	requestId := aStream uint16.
	contentLength := aStream uint16.
	paddingLength := aStream uint8.
	reserved := aStream uint8.
				! !

!FCGIHeader methodsFor: 'accessing' stamp: 'dl 2/14/2007 19:11'!
requestId
	^requestId! !

!FCGIHeader methodsFor: 'accessing' stamp: 'dl 2/14/2007 19:11'!
requestId: anInteger
	requestId := anInteger! !

!FCGIHeader methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 19:14'!
storeOn: aStream
	aStream uint8: version.
	aStream uint8: type.
	aStream uint16: requestId.
	aStream uint16: self contentLength.
	aStream uint8: self paddingLength.
	aStream uint8: 0.
				! !

!FCGIHeader methodsFor: 'accessing' stamp: 'dl 2/14/2007 00:35'!
type
	^type! !

!FCGIHeader methodsFor: 'accessing' stamp: 'dl 2/14/2007 18:45'!
type: anInteger
	type := anInteger ! !

!FCGIHeader methodsFor: 'accessing' stamp: 'dl 2/14/2007 19:01'!
version
	^version! !

!FCGIHeader methodsFor: 'accessing' stamp: 'dl 2/14/2007 19:06'!
version: anInteger
	version := anInteger! !

Object subclass: #FCGIProtocolVersion1
	instanceVariableNames: 'stream recordCollection recordCollectionOut requestId handler requestParams'
	classVariableNames: 'RecordTypes CrLf ProtocolVersion'
	poolDictionaries: ''
	category: 'FastCGI-Protocol'!

FCGIProtocolVersion1 class
	instanceVariableNames: 'logging profile'!

FCGIProtocolVersion1 class
	instanceVariableNames: 'logging profile'!

!FCGIProtocolVersion1 class methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 19:04'!
initialize
	"FCGIProtocolVersion1 initialize"
	CrLf := Character cr asString, Character lf asString.
	ProtocolVersion _ FCGIVersion1 new.
	RecordTypes _ Dictionary new.
	self recordTypesArray do: [:each | RecordTypes add: each]! !

!FCGIProtocolVersion1 class methodsFor: 'as yet unclassified' stamp: 'dl 2/17/2007 14:23'!
logging
	^logging ifNil: [logging := false]! !

!FCGIProtocolVersion1 class methodsFor: 'as yet unclassified' stamp: 'dl 2/17/2007 14:23'!
logging: aBoolean
	^logging := aBoolean! !

!FCGIProtocolVersion1 class methodsFor: 'as yet unclassified' stamp: 'dl 2/15/2007 21:25'!
on: aStream withHandler: aHandler
	^self new 
		handler: aHandler; 
		startOn: aStream;
		yourself! !

!FCGIProtocolVersion1 class methodsFor: 'as yet unclassified' stamp: 'dl 2/18/2007 15:13'!
profile
	^profile ifNil: [profile := 0]! !

!FCGIProtocolVersion1 class methodsFor: 'as yet unclassified' stamp: 'dl 2/18/2007 15:13'!
profile: anInteger
	profile := anInteger! !

!FCGIProtocolVersion1 class methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 01:21'!
recordTypesArray
	^{
		ProtocolVersion beginRequest -> FCGIBeginRequestRecord.
		ProtocolVersion abortRequest -> FCGIDefaultRecord.
		ProtocolVersion endRequest -> FCGIDefaultRecord.
		ProtocolVersion params -> FCGIParamRecord.
		ProtocolVersion stdin -> FCGIDefaultRecord.
		ProtocolVersion stdout -> FCGIDefaultRecord.
		ProtocolVersion stderr -> FCGIDefaultRecord.
		ProtocolVersion data -> FCGIDefaultRecord.
		ProtocolVersion getValue -> nil.
		ProtocolVersion getValueResult -> nil.
		ProtocolVersion unknownType -> FCGIUnknownTypeRecord.
	}! !

!FCGIProtocolVersion1 methodsFor: 'request' stamp: 'dl 2/16/2007 12:37'!
answerRequest
	| response |
	self handler isNil
		ifFalse: [
			response _ self handler process: self request.
			self sendStdout: response
		]
		ifTrue: [
			self sendHTML: '<html><head></head><body>
			<h1>Squeak/FCGI is running</h1>
			No handler set.</body></html>'
		]
! !

!FCGIProtocolVersion1 methodsFor: 'logging' stamp: 'dl 2/15/2007 21:20'!
handler
	^handler! !

!FCGIProtocolVersion1 methodsFor: 'logging' stamp: 'dl 2/15/2007 21:22'!
handler: anObject
	handler := anObject! !

!FCGIProtocolVersion1 methodsFor: 'logging' stamp: 'dl 2/17/2007 14:24'!
ifLogging: aBlock
	self class logging ifTrue: aBlock! !

!FCGIProtocolVersion1 methodsFor: 'initialize-release' stamp: 'dl 2/14/2007 19:19'!
initialize
	recordCollection _ OrderedCollection new.
	recordCollectionOut _ OrderedCollection new.	! !

!FCGIProtocolVersion1 methodsFor: 'records' stamp: 'dl 2/14/2007 01:13'!
instanceOfRecord: type
	^(RecordTypes at: type) new! !

!FCGIProtocolVersion1 methodsFor: 'logging' stamp: 'dl 2/17/2007 14:24'!
log: aString
	self ifLogging: [Transcript show: ('FCGI>>', aString); cr].! !

!FCGIProtocolVersion1 methodsFor: 'logging' stamp: 'dl 2/17/2007 14:25'!
logIncoming: record
	self ifLogging: [recordCollection add: record].
	^record! !

!FCGIProtocolVersion1 methodsFor: 'logging' stamp: 'dl 2/17/2007 14:25'!
logOutgoing: record
	self ifLogging: [recordCollectionOut add: record].
	^record! !

!FCGIProtocolVersion1 methodsFor: 'accessing' stamp: 'dl 2/18/2007 15:13'!
profile
	^self class profile! !

!FCGIProtocolVersion1 methodsFor: 'records' stamp: 'dl 2/17/2007 14:25'!
readAnyRecord
	^self logIncoming: (self readFrom: stream)! !

!FCGIProtocolVersion1 methodsFor: 'records' stamp: 'dl 2/14/2007 01:01'!
readFrom: aStream
	| header record |
	header := FCGIHeader new readFrom: aStream.
	self assert: header version = 1.
	record := self instanceOfRecord: header type.
	record header: header.
	record readFrom: aStream.
	^record! !

!FCGIProtocolVersion1 methodsFor: 'records' stamp: 'dl 2/14/2007 01:22'!
readRecord: recordClass
	| record |
	record := self readAnyRecord.
	self assert: record class = recordClass.
	^record! !

!FCGIProtocolVersion1 methodsFor: 'accessing' stamp: 'dl 2/16/2007 12:46'!
request
	^requestParams! !

!FCGIProtocolVersion1 methodsFor: 'request' stamp: 'dl 2/18/2007 15:20'!
requestLoop
	| begin |
	[begin _ (self readRecord: FCGIBeginRequestRecord)] on: Error 
	do: [:error | self log: 'disconnect'. ^false].
	self log: 'request'.
	
	[ | record |
	requestId _ begin header requestId.
	requestParams _ (self readRecord: FCGIParamRecord).
	"Stdin ist der Befehl das wir jetzt an der Reihe sind etwas auszugeben."
	[record _ self readAnyRecord] doWhileFalse: [record type = ProtocolVersion stdin].
	requestParams post: record content.
	self answerRequest.
	self sendStdout: ''.
	self sendEndRequest.
	stream flush] on: Error
	do: [:error | error pass. self log: 'requesterror'. ^false].
	
	"multiple requests in a single connection when supported by the server"
	^begin flags = ProtocolVersion keepConnection.
! !

!FCGIProtocolVersion1 methodsFor: 'records' stamp: 'dl 2/14/2007 19:17'!
sendEndRequest
	| record |
	record _ FCGIEndRequestRecord type: ProtocolVersion endRequest.
	record 
		appStatus: 0;
		protocolStatus: ProtocolVersion requestComplete.
	self sendRecord: record.
! !

!FCGIProtocolVersion1 methodsFor: 'records' stamp: 'dl 2/14/2007 19:04'!
sendHTML: aString
	self sendStdout: 'Content-type: text/html', CrLf, CrLf, aString! !

!FCGIProtocolVersion1 methodsFor: 'records' stamp: 'dl 2/17/2007 14:26'!
sendRecord: aRecord
	aRecord header 
		version: ProtocolVersion version;
		requestId: requestId;
		storeOn: stream.
		
	self logOutgoing: aRecord.
	aRecord storeOn: stream
! !

!FCGIProtocolVersion1 methodsFor: 'records' stamp: 'dl 2/16/2007 00:08'!
sendStdout: aString
	| byteCount |
	byteCount := 0.
	[byteCount < aString size] whileTrue:
	[ | amount record |
	amount := (aString size - byteCount) min: (16r10000-1).
	record _ FCGIDefaultRecord type: ProtocolVersion stdout.
	record content: (aString copyFrom: (byteCount+1) to: byteCount+amount).
	self sendRecord: record.
	byteCount := byteCount + amount]
	
	
! !

!FCGIProtocolVersion1 methodsFor: 'request' stamp: 'dl 2/18/2007 15:04'!
startOn: aStream
	stream _ aStream.
	self log: 'openConnection'.
	self startRequestLoop.
	self log: 'closeConnection'! !

!FCGIProtocolVersion1 methodsFor: 'request' stamp: 'dl 2/18/2007 15:12'!
startRequestLoop
	self profile = 0 ifTrue: [
		[self requestLoop] whileTrue
	] ifFalse: [ | count result |
		[
			count := 0.
			TimeProfileBrowser onBlock: [
				[result := self requestLoop.
				count := count + 1] doWhileTrue: [count < self profile and: [result]]
			].
			result.
		] whileTrue
	]! !

Object subclass: #FCGIRecord
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Records'!

FCGIRecord subclass: #FCGIBeginRequestRecord
	instanceVariableNames: 'role flags reserved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Records'!

!FCGIBeginRequestRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/17/2007 15:03'!
flags
	^flags! !

!FCGIBeginRequestRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 00:38'!
readFrom: aStream
	role := aStream uint16.
	flags := aStream uint8.
	reserved := aStream next: 5! !

FCGIRecord subclass: #FCGIDefaultRecord
	instanceVariableNames: 'contentData paddingData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Records'!

!FCGIDefaultRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/16/2007 12:34'!
content
	^contentData! !

!FCGIDefaultRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 19:06'!
content: aString
	contentData _ aString.
	self ensureHeader contentLength: aString size! !

!FCGIDefaultRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 00:36'!
readFrom: aStream
	contentData := aStream next: header contentLength.
	paddingData := aStream next: header paddingLength! !

!FCGIDefaultRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/16/2007 00:35'!
storeOn: aStream
	aStream nextPutAll: contentData.
	1 to: self header paddingLength do: [:each | aStream uint8: 0]! !

FCGIRecord subclass: #FCGIEndRequestRecord
	instanceVariableNames: 'appStatus protocolStatus reserved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Records'!

!FCGIEndRequestRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 19:16'!
appStatus: anInteger
	appStatus := anInteger ! !

!FCGIEndRequestRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 19:16'!
protocolStatus: anInteger
	protocolStatus := anInteger ! !

!FCGIEndRequestRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 00:35'!
readFrom: aStream
	appStatus := aStream uint32.
	protocolStatus := aStream uint8.
	reserved := aStream next: 3! !

!FCGIEndRequestRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 19:25'!
storeOn: aStream
	aStream uint32: appStatus.
	aStream uint8: protocolStatus.
	1 to: 3 do: [:each | aStream uint8: 0]
! !

FCGIRecord subclass: #FCGIParamRecord
	instanceVariableNames: 'namesAndValues cookies post fields postFields getFields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Records'!

!FCGIParamRecord methodsFor: 'accessing' stamp: 'dl 2/14/2007 20:19'!
at: aKey
	^(namesAndValues detect: [:assoc | assoc key = aKey]) value! !

!FCGIParamRecord methodsFor: 'accessing' stamp: 'dl 2/14/2007 20:44'!
at: aKey ifAbsent: aBlock
	^(namesAndValues detect: [:assoc | assoc key = aKey] ifNone: aBlock) value ! !

!FCGIParamRecord methodsFor: 'accessing' stamp: 'dl 2/16/2007 12:39'!
at: aKey put: aValue
	namesAndValues add: (aKey -> aValue)! !

!FCGIParamRecord methodsFor: 'smartaccessing' stamp: 'dl 2/14/2007 20:43'!
cookieString
	^self at: 'HTTP_COOKIE' ifAbsent: ['']! !

!FCGIParamRecord methodsFor: 'smartaccessing' stamp: 'dl 2/16/2007 12:44'!
cookies
	^cookies ifNil: [
		cookies _ self parseToFields: self cookieString separatedBy: $;.
	]! !

!FCGIParamRecord methodsFor: 'smartaccessing' stamp: 'dl 2/16/2007 12:59'!
fields
	^fields ifNil: [
		fields _ Dictionary new
			addAll: self postFields;
			addAll: self getFields;
			yourself
	]! !

!FCGIParamRecord methodsFor: 'smartaccessing' stamp: 'dl 2/16/2007 12:48'!
getFields
	^getFields ifNil: [
		getFields _ self parseToFields: self query separatedBy: $&
	]! !

!FCGIParamRecord methodsFor: 'smartaccessing' stamp: 'dl 2/14/2007 20:33'!
header
	^self! !

!FCGIParamRecord methodsFor: 'initialize-release' stamp: 'dl 2/14/2007 01:41'!
initialize
	namesAndValues := OrderedCollection new! !

!FCGIParamRecord methodsFor: 'smartaccessing' stamp: 'dl 2/14/2007 20:18'!
method
	^self at: 'REQUEST_METHOD'! !

!FCGIParamRecord methodsFor: 'reading' stamp: 'dl 2/16/2007 12:51'!
parseToFields: aString separatedBy: char
	| equal tempFields |
	tempFields _ Dictionary new.
	aString ifNotNil: [
		(aString subStrings: {char}) do: [:each |
			equal _ each indexOf: $=.
			equal = 0
				ifTrue: [tempFields at: each put: nil]
				ifFalse: [tempFields at: (each first: (equal-1)) put: (each allButFirst: equal)].
		]
	].
	^tempFields
! !

!FCGIParamRecord methodsFor: 'accessing' stamp: 'dl 2/16/2007 12:41'!
post
	^post! !

!FCGIParamRecord methodsFor: 'accessing' stamp: 'dl 2/16/2007 12:41'!
post: aString
	post := aString! !

!FCGIParamRecord methodsFor: 'smartaccessing' stamp: 'dl 2/16/2007 12:58'!
postFields
	^postFields ifNil: [
		postFields _ (self method = 'POST'
			ifTrue: [self parseToFields: self post unescapePercents separatedBy: $&]
			ifFalse: [Dictionary new])
	]! !

!FCGIParamRecord methodsFor: 'smartaccessing' stamp: 'dl 2/14/2007 20:20'!
query
	^self at: 'QUERY_STRING'! !

!FCGIParamRecord methodsFor: 'reading' stamp: 'dl 2/14/2007 01:42'!
readFrom: aStream
	| buffer stream |
	buffer := aStream next: header contentLength.
	stream := ReadStream on: buffer.
	[stream atEnd] whileFalse: [self readNameValueFrom: stream]! !

!FCGIParamRecord methodsFor: 'reading' stamp: 'dl 2/16/2007 12:40'!
readNameValueFrom: aStream
	| nameLength valueLength name value |
	nameLength _ aStream uint8.
	(nameLength bitShift: -7) = 0
		ifFalse: [nameLength _ (nameLength bitShift: 24) + aStream uint24].
		
	valueLength _ aStream uint8.
	(valueLength bitShift: -7) = 0
		ifFalse: [valueLength _ (valueLength bitShift: 24) + aStream uint24].
		
	name _ aStream next: nameLength.
	value _ aStream next: valueLength.
	self at: name put: value.! !

!FCGIParamRecord methodsFor: 'smartaccessing' stamp: 'dl 2/15/2007 22:29'!
url
	"namesAndValues explore."
	^(self at: 'SCRIPT_NAME'), (self at: 'PATH_INFO')! !

!FCGIRecord class methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 18:44'!
type: anInteger
	^self new type: anInteger! !

!FCGIRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 18:45'!
ensureHeader 
	^self header ifNil: [header := FCGIHeader new]! !

!FCGIRecord methodsFor: 'accessing' stamp: 'dl 2/14/2007 00:22'!
header
	^header! !

!FCGIRecord methodsFor: 'accessing' stamp: 'dl 2/14/2007 00:22'!
header: anObject
	header := anObject! !

!FCGIRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 01:23'!
type
	^header type! !

!FCGIRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 18:44'!
type: anInteger
	self ensureHeader type: anInteger! !

FCGIRecord subclass: #FCGIUnknownTypeRecord
	instanceVariableNames: 'type reserved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Records'!

!FCGIUnknownTypeRecord methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 00:39'!
readFrom: aStream
	type := aStream uint8.
	reserved := aStream next: 7! !

Object subclass: #FCGIServer
	instanceVariableNames: 'handler port socket profile process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Server'!

!FCGIServer commentStamp: 'dl 2/14/2007 00:02' prior: 0!
FastCGI Specifiaction at

http://www.fastcgi.com/devkit/doc/fcgi-spec.html!

!FCGIServer class methodsFor: 'as yet unclassified' stamp: 'dl 2/15/2007 21:42'!
startInBackground
	self new openInProcess! !

!FCGIServer methodsFor: 'as yet unclassified' stamp: 'dl 2/18/2007 14:58'!
acceptLoop
	| requestSocket |
	self assert: (socket isValid).
	(requestSocket _ socket waitForAccept)
		ifNotNil: [ | stream |
			[requestSocket setOption: 'TCP_NODELAY' value: true.
			stream _ (SocketStream on: requestSocket).
			stream timeout: 0.
			self protocol 
				on: stream
				withHandler: self handler]
			ensure: [requestSocket _ nil]
		].
! !

!FCGIServer methodsFor: 'accessing' stamp: 'dl 2/15/2007 21:24'!
handler
	^handler! !

!FCGIServer methodsFor: 'accessing' stamp: 'dl 2/15/2007 21:24'!
handler: anObject
	handler := anObject! !

!FCGIServer methodsFor: 'initialize-release' stamp: 'dl 2/16/2007 00:51'!
initialize
	profile := 0! !

!FCGIServer methodsFor: 'as yet unclassified' stamp: 'dl 2/18/2007 18:19'!
listen
	socket listenOn: self port backlogSize: 4.
	profile = 0
		ifTrue: [self listenDefault]
		ifFalse: [self listenProfiled]! !

!FCGIServer methodsFor: 'as yet unclassified' stamp: 'dl 2/16/2007 00:53'!
listenDefault
	[self acceptLoop] repeat.! !

!FCGIServer methodsFor: 'as yet unclassified' stamp: 'dl 2/16/2007 00:53'!
listenProfiled
	[
		TimeProfileBrowser onBlock: [
		1 to: 100 do: [:i |
		self acceptLoop]]
	] repeat.! !

!FCGIServer methodsFor: 'as yet unclassified' stamp: 'dl 2/13/2007 23:37'!
open
	socket := Socket newTCP.
	[self listen]
	ensure: [socket close]
! !

!FCGIServer methodsFor: 'as yet unclassified' stamp: 'dl 2/16/2007 13:14'!
openInProcess
	process := ([self open]
	forkAt: Processor userBackgroundPriority named: 'fcgi-server')! !

!FCGIServer methodsFor: 'as yet unclassified' stamp: 'dl 2/15/2007 22:01'!
port
	^port ifNil: [port := 9000]! !

!FCGIServer methodsFor: 'as yet unclassified' stamp: 'dl 2/15/2007 22:00'!
port: anInteger
	port := anInteger! !

!FCGIServer methodsFor: 'accessing' stamp: 'dl 2/16/2007 00:53'!
profile
	"Answer the value of profile"

	^ profile! !

!FCGIServer methodsFor: 'accessing' stamp: 'dl 2/16/2007 00:53'!
profile: anObject
	"Set the value of profile"

	profile := anObject! !

!FCGIServer methodsFor: 'as yet unclassified' stamp: 'dl 2/14/2007 01:10'!
protocol
	^FCGIProtocolVersion1! !

!FCGIServer methodsFor: 'accessing' stamp: 'dl 2/16/2007 00:53'!
socket
	"Answer the value of socket"

	^ socket! !

!FCGIServer methodsFor: 'accessing' stamp: 'dl 2/16/2007 00:53'!
socket: anObject
	"Set the value of socket"

	socket := anObject! !

!FCGIServer methodsFor: 'as yet unclassified' stamp: 'dl 2/16/2007 13:15'!
stop
	process ifNotNil: [
		process isTerminated ifFalse: [process terminate]
	]! !

Object subclass: #FCGIVersion1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Protocol'!

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:03'!
abortRequest
	^2! !

!FCGIVersion1 methodsFor: 'role-constants' stamp: 'dl 2/13/2007 23:09'!
authorizer
	^2! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:03'!
beginRequest
	^1! !

!FCGIVersion1 methodsFor: 'request-constants' stamp: 'dl 2/13/2007 23:15'!
cantMultiplexConnection! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:04'!
data
	^8! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:04'!
endRequest
	^3! !

!FCGIVersion1 methodsFor: 'role-constants' stamp: 'dl 2/13/2007 23:09'!
filter
	^3! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/14/2007 00:31'!
getMaxtype
	^self unknownType! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:04'!
getValue
	^9! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:04'!
getValueResult
	^10! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:03'!
headerLength
	^8! !

!FCGIVersion1 methodsFor: 'request-constants' stamp: 'dl 2/13/2007 23:15'!
keepConnection
	^1! !

!FCGIVersion1 methodsFor: 'config-defaults' stamp: 'dl 2/13/2007 23:16'!
maxConnections
	^1! !

!FCGIVersion1 methodsFor: 'config-defaults' stamp: 'dl 2/13/2007 23:16'!
maxRequests
	^1! !

!FCGIVersion1 methodsFor: 'config-defaults' stamp: 'dl 2/13/2007 23:16'!
multiplexConnections
	^0! !

!FCGIVersion1 methodsFor: 'request-constants' stamp: 'dl 2/13/2007 23:05'!
nullRequestID
	^0! !

!FCGIVersion1 methodsFor: 'request-constants' stamp: 'dl 2/13/2007 23:15'!
overloaded
	^2! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:04'!
params
	^4! !

!FCGIVersion1 methodsFor: 'request-constants' stamp: 'dl 2/13/2007 23:15'!
requestComplete
	^0! !

!FCGIVersion1 methodsFor: 'role-constants' stamp: 'dl 2/13/2007 23:09'!
responder
	^1! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:04'!
stderr
	^7! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:04'!
stdin
	^5! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:04'!
stdout
	^6! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/14/2007 00:31'!
unknownType
	^11! !

!FCGIVersion1 methodsFor: 'request-constants' stamp: 'dl 2/13/2007 23:15'!
unkownRole
	^3! !

!FCGIVersion1 methodsFor: 'header-constants' stamp: 'dl 2/13/2007 23:03'!
version
	^1! !

!ReadStream methodsFor: '*fastcgi' stamp: 'dl 2/14/2007 01:44'!
uint8
	^self next asInteger! !

SocketStream subclass: #FCGISocketStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Stream'!

!SocketStream methodsFor: '*fastcgi' stamp: 'dl 2/14/2007 00:27'!
uint16
	"Answer the next unsigned, 16-bit integer from this (binary) stream."

	| n |
	n _ self uint8.
	n _ (n bitShift: 8) + (self uint8).
	^ n
! !

!SocketStream methodsFor: '*fastcgi' stamp: 'dl 2/13/2007 23:56'!
uint16: anInteger
	"Store the given unsigned, 16-bit integer on this (binary) stream."

	(anInteger < 0) | (anInteger >= 16r10000)
		ifTrue: [self error: 'outside unsigned 16-bit integer range'].

	self nextPut: (anInteger digitAt: 2).
	self nextPut: (anInteger digitAt: 1).
! !

!SocketStream methodsFor: '*fastcgi' stamp: 'dl 2/14/2007 00:27'!
uint24
	"Answer the next unsigned, 24-bit integer from this (binary) stream."

	| n |
	n _ self uint8.
	n _ (n bitShift: 8) + self uint8.
	n _ (n bitShift: 8) + self uint8.
	^ n
! !

!SocketStream methodsFor: '*fastcgi' stamp: 'dl 2/14/2007 00:27'!
uint32
	"Answer the next unsigned, 32-bit integer from this (binary) stream."

	| n |
	n _ self uint8.
	n _ (n bitShift: 8) + self uint8.
	n _ (n bitShift: 8) + self uint8.
	n _ (n bitShift: 8) + self uint8.
	^ n
! !

!SocketStream methodsFor: '*fastcgi' stamp: 'dl 2/13/2007 23:56'!
uint32: anInteger
	"Store the given unsigned, 32-bit integer on this (binary) stream."

	(anInteger < 0) | (anInteger >= 16r100000000)
		ifTrue: [self error: 'outside unsigned 32-bit integer range'].

	self nextPut: (anInteger digitAt: 4).
	self nextPut: (anInteger digitAt: 3).
	self nextPut: (anInteger digitAt: 2).
	self nextPut: (anInteger digitAt: 1).
! !

!SocketStream methodsFor: '*fastcgi' stamp: 'dl 2/14/2007 00:27'!
uint8
	^self next asInteger! !

!SocketStream methodsFor: '*fastcgi' stamp: 'dl 2/14/2007 19:09'!
uint8: anInteger
	"Store the given unsigned, 8-bit integer on this (binary) stream."

	(anInteger < 0) | (anInteger >= 8r10000)
		ifTrue: [self error: 'outside unsigned 16-bit integer range'].

	self nextPut: anInteger
! !

WAKom subclass: #WAFCGI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Seaside'!

WAFCGI class
	instanceVariableNames: 'Profile'!

WAFCGI class
	instanceVariableNames: 'Profile'!

!WAFCGI class methodsFor: 'as yet unclassified' stamp: 'dl 2/16/2007 00:56'!
initialize
	"self initialize"
	super initialize.
	self profile: 0! !

!WAFCGI class methodsFor: 'accessing' stamp: 'dl 2/16/2007 00:56'!
profile
	^Profile! !

!WAFCGI class methodsFor: 'accessing' stamp: 'dl 2/16/2007 00:56'!
profile: anObject
	Profile := anObject! !

!WAFCGI class methodsFor: 'as yet unclassified' stamp: 'dl 2/17/2007 01:08'!
shutDown
! !

!WAFCGI class methodsFor: 'as yet unclassified' stamp: 'dl 2/16/2007 00:54'!
startOn: aPort
	| server |
	port := aPort.
	server := FCGIServer new
		handler: self default;
		port: port;
		profile: self profile;
		openInProcess.! !

!WAFCGI class methodsFor: 'as yet unclassified' stamp: 'dl 2/17/2007 01:08'!
startUp
	! !

!WAFCGI methodsFor: 'as yet unclassified' stamp: 'dl 2/16/2007 13:01'!
convertRequest: aFCGIParamRequest
	| request |
	"TODO ->"
	"self processMultipartFields: aKomRequest."
	
	request _ WARequest
		method: aFCGIParamRequest method
		url: aFCGIParamRequest url unescapePercents 
		headers: aFCGIParamRequest header
		fields: (aFCGIParamRequest method = 'POST'
			ifTrue: [aFCGIParamRequest postFields]
			ifFalse: [aFCGIParamRequest getFields])
		cookies: aFCGIParamRequest cookies
		nativeRequest: aFCGIParamRequest.

	"More TODO"
	"aKomRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (aKomRequest stream next: aKomRequest contentLength)]."
	^ request! !

!WAFCGI methodsFor: 'as yet unclassified' stamp: 'dl 2/17/2007 15:24'!
convertResponse: aResponse
	| response |
	aResponse ifNil: [^ HttpResponse fromString: 'Request handling aborted; reload to retry'].
	response := (FCGIWriteStream on: (String new)).
	aResponse writeHeadersOn: response.
	response crlf; nextPutAll: aResponse stream contents.
	^response contents
! !

!WAFCGI methodsFor: 'accessing' stamp: 'dl 2/17/2007 15:11'!
log: request
	! !

WriteStream subclass: #FCGIWriteStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FastCGI-Stream'!

!FCGIWriteStream methodsFor: 'as yet unclassified' stamp: 'dl 2/15/2007 21:49'!
crlf
	self nextPutAll: String crlf! !

!Socket methodsFor: '*fastcgi' stamp: 'dl 2/16/2007 16:53'!
waitForAccept
	self waitForConnection.
	^self accept! !

!Socket methodsFor: '*fastcgi' stamp: 'dl 2/16/2007 17:03'!
waitForConnection
	"Wait up until the given deadline for a connection to be established. Return true if it is established by the deadline, false if not."
	| status |
	
	[status _ self primSocketConnectionStatus: socketHandle.
	status = WaitingForConnection] whileTrue: [semaphore wait].
	status _ self primSocketConnectionStatus: socketHandle.
	self assert: Connected = status.
	self primSocketConnectionStatus: socketHandle
! !
FCGIProtocolVersion1 initialize!
WAFCGI initialize!
